/**
 * QApplication wrapper that can act as a Sugar activity
 *
 * (C) 2007 Bernhard Rosenkraenzer <bero@arklinux.org>
 *
 * Released under the terms of the GNU General Public License (GPL)
 * version 2, or, at your opinion, any later version of the GPL
 * published by the Free Software Foundation.
 *
 * For alternative licensing options, contact bero@arklinux.org
 */
#ifndef _QACTIVITY_H_
#define _QACTIVITY_H_ 1
#include <QApplication>
#include <QDBusAbstractAdaptor>
#include <QDBusVariant>
#include <QWidget>
#include <QString>
#include <QUrl>

class SugarDBusAdaptor:public QDBusAbstractAdaptor {
	Q_OBJECT
	Q_CLASSINFO("D-Bus Interface", "org.laptop.Activity")
public:
	explicit SugarDBusAdaptor(QObject *parent):QDBusAbstractAdaptor(parent) { }
public slots:
	void setActive(bool active)	{ emit setActive(active); }
	void TakeScreenshot()		{ emit takeScreenshot(); }
	void Invite(QString key)	{ emit invite(key); }
signals:
	void SetActive(bool active);
	void takeScreenshot();
	void invite(QString key);
};

class QActivity:public QApplication {
	Q_OBJECT
public:
	QActivity(int &argc, char **argv);
	~QActivity();
	void setTopLevelWidget(QWidget *w);
	QString const &dataDir() const { return _dataDir; }
	QString const &instanceDir() const { return _instanceDir; }
	QString const &tmpDir() const { return _tmpDir; }
	bool inSugar() const;
signals:
	void setActive(bool active);
	void takeScreenshot();
	void invite(QString key);
protected:
	QWidget	*_toplevel;
	SugarDBusAdaptor	*_dbus;
	QString _bundleId;
	QString _activityId;
	QString _objectId;
	QString _dataDir;
	QString _instanceDir;
	QString _tmpDir;
	QUrl	_uri;
};
#endif
