#include <QActivity.h>
#include "MainWidget.moc"
#include <iostream>

extern "C" {
#include <sys/syslog.h>
}

using namespace std;

MainWidget::MainWidget():QLabel(tr("Qt stuff running on XO"), 0) {
}

void MainWidget::activate(bool act) {
	hide();
	if(act)
		show();
}

void MainWidget::screenshot() {
	syslog(LOG_ERR, "MainWidget: got screenshot signal");
}

void MainWidget::invite(QString who) {
	syslog(LOG_ERR, "MainWidget: got invite signal for %s", who.toLatin1().data());
}

int main(int argc, char **argv) {
	QActivity app(argc, argv);
	MainWidget *mainWidget=new MainWidget;
	app.setTopLevelWidget(mainWidget);
	mainWidget->show();
	QObject::connect(&app, SIGNAL(setActive(bool)), mainWidget, SLOT(activate(bool)));
	QObject::connect(&app, SIGNAL(takeScreenshot()), mainWidget, SLOT(screenshot()));
	QObject::connect(&app, SIGNAL(invite(QString)), mainWidget, SLOT(invite(QString)));
	app.exec();
}
